#include "common.h"

int sub_read_config(CONFIG_INFO_T *pftpt)
{
	FILE	*fp ;
	char	filbuf[1024] ;
	char	wrkbuf[1024] ;
	char	*pt ;
	char	*ps ;
	char	*pv ;
	int		nsts ;

	if ( (fp = fopen(pftpt->fil_config,"r")) == NULL )
	{
		fprintf( stderr, "file (%s) read error", pftpt->fil_config ) ;
		return STS_NG ;
	}

	nsts = STS_OK ;

	while ( fgets( filbuf, sizeof(filbuf), fp ) )
	{
		for ( pt=filbuf; *pt && isspace(*pt); pt++ );			// skip space
		if  ( *pt == 0 )
		{
			continue ;
		}
		if  ( *pt == '#' )										// comment
		{
			continue ;
		}

		memset(wrkbuf, 0, sizeof(wrkbuf) ) ;

		for( ps=wrkbuf; *pt && !isspace(*pt); *ps++=*pt++ ) ;	//	Get Key

		for ( ; *pt && isspace(*pt); pt++ );					// skip space
		if  ( *pt == 0 )
		{
			fprintf( stderr, "Syntax Error:%s", filbuf);
			nsts = STS_NG ;
			break ;
		}
		if  ( *pt != '=' )										//	must be '='
		{
			fprintf( stderr, "Syntax Error:%s", filbuf);
			nsts = STS_NG ;
			break ;
		}
		for ( pt++; *pt && isspace(*pt); pt++ );				// skip space
		if  ( *pt == 0 )
		{
			fprintf( stderr, "Syntax Error:%s", filbuf);
			nsts = STS_NG ;
			break ;
		}
		if  ( *pt != 0x27 )										//	must be "'"
		{
			fprintf( stderr, "Syntax Error:%s", filbuf);
			nsts = STS_NG ;
			break ;
		}

		if ( !strcmp( wrkbuf, "dir_primary" ))
		{
			memset( pftpt->dir_primary, 0, sizeof(pftpt->dir_primary) ) ;
			pv = ps = pftpt->dir_primary ;
		}
		else if ( !strcmp( wrkbuf, "del_method" ) )
		{
			memset( pftpt->del_method, 0, sizeof(pftpt->del_method) ) ;
			pv = ps = pftpt->del_method ;
		}
		else if ( !strcmp( wrkbuf, "dir_secondary" ) )
		{
			memset( pftpt->dir_secondary, 0, sizeof(pftpt->dir_secondary) ) ;
			pv = ps = pftpt->dir_secondary ;
		}
		else if ( !strcmp( wrkbuf, "tim_sleep" ) ) 
		{
			memset( pftpt->tim_sleep, 0, sizeof(pftpt->tim_sleep) ) ;
			pv = ps = pftpt->tim_sleep ;
		}
		else if ( !strcmp( wrkbuf, "dir_archive" ) ) 
		{
			memset( pftpt->dir_archive, 0, sizeof(pftpt->dir_archive) ) ;
			pv = ps = pftpt->dir_archive ;
		}
		else if ( !strcmp( wrkbuf, "dir_workdir" ) ) 
		{
			memset( pftpt->dir_workdir, 0, sizeof(pftpt->dir_workdir) ) ;
			pv = ps = pftpt->dir_workdir ;
		}
		else if ( !strcmp( wrkbuf, "ftp_server" ) ) 
		{
			memset( pftpt->ftp_server, 0, sizeof(pftpt->ftp_server) ) ;
			pv = ps = pftpt->ftp_server ;
		}
		else if ( !strcmp( wrkbuf, "ftp_user" ) ) 
		{
			memset( pftpt->ftp_user, 0, sizeof(pftpt->ftp_user) ) ;
			pv = ps = pftpt->ftp_user ;
		}
		else if ( !strcmp( wrkbuf, "ftp_pass" ) ) 
		{
			memset( pftpt->ftp_pass, 0, sizeof(pftpt->ftp_pass) ) ;
			pv = ps = pftpt->ftp_pass ;
		}
		else if ( !strcmp( wrkbuf, "ftp_destination" ) ) 
		{
			memset( pftpt->ftp_destination, 0, sizeof(pftpt->ftp_destination) ) ;
			pv = ps = pftpt->ftp_destination ;
		}
		else if ( !strcmp( wrkbuf, "fil_destination" ) ) 
		{
			memset( pftpt->fil_destination, 0, sizeof(pftpt->fil_destination) ) ;
			pv = ps = pftpt->fil_destination ;
		}
		else if ( !strcmp( wrkbuf, "output_order" ) ) 
		{
			memset( pftpt->output_order, 0, sizeof(pftpt->output_order) ) ;
			pv = ps = pftpt->output_order ;
		}
		else if ( !strcmp( wrkbuf, "total_cell" ) ) 
		{
			memset( pftpt->total_cell, 0, sizeof(pftpt->total_cell) ) ;
			pv = ps = pftpt->total_cell ;
		}
		else if ( !strcmp( wrkbuf, "tim_duration" ) ) 
		{
			memset( pftpt->tim_duration, 0, sizeof(pftpt->tim_duration) ) ;
			pv = ps = pftpt->tim_duration ;
		}
		else if ( !strcmp( wrkbuf, "dir_target" ) ) 
		{
			memset( pftpt->dir_target, 0, sizeof(pftpt->dir_target) ) ;
			pv = ps = pftpt->dir_target ;
		}
		else if ( !strcmp( wrkbuf, "post_run" ) ) 
		{
			memset( pftpt->post_run, 0, sizeof(pftpt->post_run) ) ;
			pv = ps = pftpt->post_run ;
		}
		else if ( !strcmp( wrkbuf, "proc_name_01" ) ) 
		{
			memset( pftpt->proc_name_01, 0, sizeof(pftpt->proc_name_01) ) ;
			pv = ps = pftpt->proc_name_01 ;
		}
		else if ( !strcmp( wrkbuf, "proc_name_02" ) ) 
		{
			memset( pftpt->proc_name_02, 0, sizeof(pftpt->proc_name_02) ) ;
			pv = ps = pftpt->proc_name_02 ;
		}
		else if ( !strcmp( wrkbuf, "proc_name_03" ) ) 
		{
			memset( pftpt->proc_name_03, 0, sizeof(pftpt->proc_name_03) ) ;
			pv = ps = pftpt->proc_name_03 ;
		}
		else if ( !strcmp( wrkbuf, "proc_name_04" ) ) 
		{
			memset( pftpt->proc_name_04, 0, sizeof(pftpt->proc_name_04) ) ;
			pv = ps = pftpt->proc_name_04 ;
		}
		else if ( !strcmp( wrkbuf, "proc_name_05" ) ) 
		{
			memset( pftpt->proc_name_05, 0, sizeof(pftpt->proc_name_05) ) ;
			pv = ps = pftpt->proc_name_05 ;
		}
		else if ( !strcmp( wrkbuf, "dir_logdir" ) ) 
		{
			memset( pftpt->dir_logdir, 0, sizeof(pftpt->dir_logdir) ) ;
			pv = ps = pftpt->dir_logdir ;
		}
		else if ( !strcmp( wrkbuf, "fil_target" ) ) 
		{
			memset( pftpt->fil_target, 0, sizeof(pftpt->fil_target) ) ;
			pv = ps = pftpt->fil_target ;
		}
		else if ( !strcmp( wrkbuf, "fil_name" ) ) 
		{
			memset( pftpt->fil_name, 0, sizeof(pftpt->fil_name) ) ;
			pv = ps = pftpt->fil_name ;
		}
		else if ( !strcmp( wrkbuf, "set_option_01" ) ) 
		{
			memset( pftpt->set_option_01, 0, sizeof(pftpt->set_option_01) ) ;
			pv = ps = pftpt->set_option_01 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_02" ) ) 
		{
			memset( pftpt->set_option_02, 0, sizeof(pftpt->set_option_02) ) ;
			pv = ps = pftpt->set_option_02 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_03" ) ) 
		{
			memset( pftpt->set_option_03, 0, sizeof(pftpt->set_option_03) ) ;
			pv = ps = pftpt->set_option_03 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_04" ) ) 
		{
			memset( pftpt->set_option_04, 0, sizeof(pftpt->set_option_04) ) ;
			pv = ps = pftpt->set_option_04 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_05" ) ) 
		{
			memset( pftpt->set_option_05, 0, sizeof(pftpt->set_option_05) ) ;
			pv = ps = pftpt->set_option_05 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_06" ) ) 
		{
			memset( pftpt->set_option_06, 0, sizeof(pftpt->set_option_06) ) ;
			pv = ps = pftpt->set_option_06 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_07" ) ) 
		{
			memset( pftpt->set_option_07, 0, sizeof(pftpt->set_option_07) ) ;
			pv = ps = pftpt->set_option_07 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_08" ) ) 
		{
			memset( pftpt->set_option_08, 0, sizeof(pftpt->set_option_08) ) ;
			pv = ps = pftpt->set_option_08 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_09" ) ) 
		{
			memset( pftpt->set_option_09, 0, sizeof(pftpt->set_option_09) ) ;
			pv = ps = pftpt->set_option_09 ;
		}
		else if ( !strcmp( wrkbuf, "set_option_10" ) ) 
		{
			memset( pftpt->set_option_10, 0, sizeof(pftpt->set_option_10) ) ;
			pv = ps = pftpt->set_option_10 ;
		}
		else if ( !strcmp( wrkbuf, "dir_destination" ) ) 
		{
			memset( pftpt->dir_destination, 0, sizeof(pftpt->dir_destination) ) ;
			pv = ps = pftpt->dir_destination ;
		}
		else if ( !strcmp( wrkbuf, "ast_port" ) ) 
		{
			memset( pftpt->ast_port, 0, sizeof(pftpt->ast_port) ) ;
			pv = ps = pftpt->ast_port ;
		}
		else if ( !strcmp( wrkbuf, "ast_host" ) ) 
		{
			memset( pftpt->ast_host, 0, sizeof(pftpt->ast_host) ) ;
			pv = ps = pftpt->ast_host ;
		}
		else if ( !strcmp( wrkbuf, "min_size" ) ) 
		{
			memset( pftpt->min_size, 0, sizeof(pftpt->min_size) ) ;
			pv = ps = pftpt->min_size ;
		}
		else
		{
			fprintf( stderr, "Syntax Error:%s", filbuf);
			nsts = STS_NG ;
			break ;
		}

		for ( pt++; *pt && *pt != 0x27; *ps++ = *pt++ ) ;

		sub_logput( LOG_NORML, "(%s) => (%s)", wrkbuf, pv ) ;
	}

	fclose( fp ) ;

	//
	//	Generate File Name
	//

	snprintf( pftpt->fil_check1, sizeof(pftpt->fil_check1), "%s/checkdata1.txt", pftpt->dir_workdir ) ;
	snprintf( pftpt->fil_check2, sizeof(pftpt->fil_check2), "%s/checkdata2.txt", pftpt->dir_workdir ) ;
	snprintf( pftpt->fil_catalog,sizeof(pftpt->fil_catalog),"%s/catalog.txt", pftpt->dir_workdir ) ;

	return nsts ;
}
